/*  crt_head.S                                                  (CRC:c6e636ca)
 *      relative path: ./lib/boot/m-pc
 *      creation date: Wed Jan  3 19:07:45 1996
 *      last modified: Sat Oct 26 15:09:58 1996
 *      header update: Sat Oct 26 15:09:59 1996
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        (boot)
 *         (m-pc)
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution.
 *  
 *  Shag/OS is free software for non-profit uses; it may be freely distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'COPYING'.  If this license was not received,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For bug reports, please read the file 'BUGS' first, then include the 
 *      product name and version, and the word 'bug' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

.text

// NOTE: (this applies to all assembly code)
//   C functions on the 386 will automatically save all registers
//   used except eax, ecx, and edx



// call global constructors for either elf or a.out format:
//	a.out:  len xxx xxx xxx etc...
//	elf:    -1 xxx xxx xxx 0


.globl __do_global_ctors
__do_global_ctors:
	pushl	%ebx
	movl	$__CTOR_LIST__,%ebx
	movl	(%ebx),%eax
	cmpl	$-1,%eax
	je	1f				// for ELF-style
	leal	__CTOR_LIST__+4(%eax,4),%ebx	// for a.out style
	jmp	2f

1:	addl	$4,%ebx			
	cmpl	$0,(%ebx)			// find end of list
	jne	1b

2:	subl	$4,%ebx
	cmpl	$__CTOR_LIST__,%ebx		// if at start
	je	3f				// then stop
	movl	(%ebx),%eax			
	call	%eax				// else call constructor
	jmp	2b				// and loop

3:	popl	%ebx
	ret



.globl __do_global_dtors
__do_global_dtors:
	pushl	%ebx
	movl	$__DTOR_LIST__,%ebx

1:	addl	$4,%ebx
	movl	(%ebx),%eax
	testl	%eax,%eax
	jz	2f
	call	%eax
	jmp	1b

2:	popl	%ebx
	ret





#ifdef __ELF__

.section .ctors,"aw"
__CTOR_LIST__:
	.long	0xffffffff


.section .dtors,"aw"
__DTOR_LIST__:
	.long	0xffffffff


#else // ! __ELF__
// set lists:

.globl __func_nop
__func_nop:
	ret

.stabs "___CTOR_LIST__",0,0,0,__func_nop
.stabs "___DTOR_LIST__",0x17,0,0,__func_nop

#endif

