/*  $Id: srt0.S,v 1.1 1996/01/03 19:07:45 shaggy Exp shaggy $
 *      Standalone RunTime for C/C++ programs
 *      
 *      relative path: ./lib/boot/m-pc
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        (boot)
 *         (m-pc)
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution.
 *  
 *  Shag/OS is free software for non-profit uses; it may be freely distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'COPYING'.  If this license was not received,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For bug reports, please read the file 'BUGS' first, then include the 
 *      product name and version, and the word 'bug' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  $Log: srt0.S,v $
 *  Revision 1.1  1996/01/03  19:07:45  shaggy
 *  Initial revision
 *
 */


#include <boot/bootparam.h>

// note about stacks:
//	if 'initial_stack_top' is non-zero, then this is used for
//	the stack top, otherwise, 'initial_stack_size' bytes are reserved.
 

.text

// NOTE: (this applies to all assembly code)
//   C functions on the 386 will automatically save all registers
//   used except eax, ecx, and edx


.globl _start
//	start code for kernel; called from SOLO 
//	in:	ebx = address of BootParam structure
//	out:	eax = exit value
//		and other registers in unknown states
_start:
	movl	%ebx,bootparam
	movb	$1,_bootparam_initialized
	movl	initial_stack_top,%eax
	or	%eax,%eax
	jnz	1f	
	mov	BootParam_himem(%ebx),%eax
	mov	%edx,initial_stack_size
	sub	BootParam_himem(%ebx),%edx	// adjust himem
1: 	
	mov	%eax,%esp

	call	__do_global_ctors

	movl	bootparam,%ebx
	movl	BootParam_envp(%ebx),%eax
	movl	%eax,environ
	pushl	%eax
	pushl	BootParam_argv(%ebx)
	pushl	BootParam_argc(%ebx)
	call	main
	addl	$12,%esp

	pushl	%eax
	call	__do_global_dtors
	popl	%eax

	movl	bootparam,%ebx
	pushl	%eax
	jmp	*BootParam_exit(%ebx)


// BootParam *bootparam
.globl bootparam
bootparam:
	.long	0

// bool _bootparam_initialized:
.globl _bootparam_initialized
_bootparam_initialized:	
	.byte	0


// bool _bootparam_init()
.globl _bootparam_init
_bootparam_init:
	movb	_bootparam_initialized,%al
	ret


// char **environ;
.globl environ
environ:
	.long	0


#ifndef __ELF__
.globl ___main
___main:
	ret
#endif

