/*  btypes.h                                                    (CRC:b18a723b)
 *      relative path: ./lib
 *      creation date: Dec 1994
 *      last modified: Sat Oct 12 12:19:14 1996
 *      header update: Sat Oct 26 15:08:31 1996
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution.
 *  
 *  Shag/OS is free software for non-profit uses; it may be freely distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'COPYING'.  If this license was not received,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For bug reports, please read the file 'BUGS' first, then include the 
 *      product name and version, and the word 'bug' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  basic data type definitions
 */

#define _K_	1024			// Kilo (2^10)
#define	_M_	1048576			// Mega (2^20)
#define _G_	1073741824		// Giga (2^30)
#define _T_	1099511627776		// Tera (2^40)


#ifndef ASM

typedef unsigned char		uchar;
typedef signed char		schar;
typedef unsigned short int	ushort;
typedef unsigned long int	ulong;
typedef unsigned long long int	ullong;
typedef long long int		llong;
typedef unsigned int		uint;
 
typedef long double 	ldouble;

typedef uint8	flag8;
typedef uint16	flag16;
typedef uint32	flag32;
typedef uint64	flag64;

// deprecated, hopefully:
//
// typedef void	fvoid_t();
// typedef int	fint_t();
// typedef char	*fstr_t();
// typedef int	fmain_t(int argc, char **argv);

typedef uchar 		lock_t; 
// typedef	uint32		obj_t;
// typedef obj_t		status_t;
// typedef obj_t		label_t;


// Note that 'signed char' and 'unsigned char'
// are *not* included as builtin char types, because
// when the signed-ness of a char type is being depended upon,
// it is generally being used as an integer, not a character.

#ifndef FOR_ALL_BUILTIN_CHAR_TYPES
#define FOR_ALL_BUILTIN_CHAR_TYPES(x)	\
		x(char) x(wchar_t)
#endif

#ifndef FOR_ALL_BUILTIN_INT_TYPES
#define FOR_ALL_BUILTIN_INT_TYPES(x)	\
		x(int8) x(uint8) \
		x(int16) x(uint16) \
		x(int32) x(uint32) \
		x(int64) x(uint64)
#endif

#ifndef FOR_ALL_BUILTIN_FLOAT_TYPES
#define FOR_ALL_BUILTIN_FLOAT_TYPES(x)	\
		x(float) x(double) x(long double)
#endif

#ifndef FOR_ALL_BUILTIN_TYPES
#define FOR_ALL_BUILTIN_TYPES(x)	FOR_ALL_BUILTIN_CHAR_TYPES(x)	\
					FOR_ALL_BUILTIN_INT_TYPES(x)	\
					FOR_ALL_BUILTIN_FLOAT_TYPES(x)	
#endif

#endif	/* ASM */

