//  packed.H                                                    (CRC:c95ac936)
//      relative path: ./lib/c++
//      creation date: Sat Apr 13 16:40:02 1996
//      last modified: Sat Oct 26 15:08:07 1996
//      header update: Sat Oct 26 15:08:08 1996
//  
//      Shag/OS: an Object-Oriented MicroKernel Operating System
//       Libraries
//        C++ specific code
//  
//  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
//  
//  This file is a part of the Shag/OS operating system distribution.
//  
//  Shag/OS is free software for non-profit uses; it may be freely distributed
//  for non-profit purposes under the terms of the Shag/OS License, version 1.
//  
//  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
//  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
//  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
//  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
//  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
//  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
//  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
//  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
//  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
//  
//  You should have received a copy of the Shag/OS License along with this
//  program, in a file called 'COPYING'.  If this license was not received,
//  please contact the author and describe how this software was obtained.
//  
//  The author can be reached for questions, comments, and suggestions at:
//  
//      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
//      email:   shaggy@csh.rit.edu
//  
//      For bug reports, please read the file 'BUGS' first, then include the 
//      product name and version, and the word 'bug' in the subject.
//  
//  Complete, unaltered, original distributions of this and related code
//  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
//  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy

// XXX - This code ought to be temporary, but
// for now, GCC 2.7.2 is broken and doesn't correctly support
// __attribute__((packed)), and so these data types must be
// substituted in structures that need a smaller alignment than
// the default.

// Actually, other compilers might not support the equivalent
// of __attribute__((packed)), so this might be a good idea to try
// to write all code that depends on packing using these routines,
// to increase portability.  (will this technique work on all systems?)


template <class T> class packed {
        uchar b[sizeof(T)];
public:
        T& operator=(T n)
                { *(T*)b = n; return *(T*)b; }
        operator T() const { return *(T*)b; }
};


inline template class packed<uint8>;	// redundant and unnecessary
inline template class packed<uint16>;
inline template class packed<uint32>;
inline template class packed<uint64>;
inline template class packed<int8>;	// redundant, unnecessary, 
					// and repetitive
inline template class packed<int16>;
inline template class packed<int32>;
inline template class packed<int64>;

