//  vdir.H                                                      (CRC:fac282b2)
//      relative path: ./lib/c++
//      creation date: Sun Apr 14 20:17:26 1996
//      last modified: Sat Oct 26 15:08:10 1996
//      header update: Sat Oct 26 15:08:11 1996
//  
//      Shag/OS: an Object-Oriented MicroKernel Operating System
//       Libraries
//        C++ specific code
//  
//  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
//  
//  This file is a part of the Shag/OS operating system distribution.
//  
//  Shag/OS is free software for non-profit uses; it may be freely distributed
//  for non-profit purposes under the terms of the Shag/OS License, version 1.
//  
//  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
//  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
//  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
//  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
//  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
//  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
//  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
//  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
//  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
//  
//  You should have received a copy of the Shag/OS License along with this
//  program, in a file called 'COPYING'.  If this license was not received,
//  please contact the author and describe how this software was obtained.
//  
//  The author can be reached for questions, comments, and suggestions at:
//  
//      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
//      email:   shaggy@csh.rit.edu
//  
//      For bug reports, please read the file 'BUGS' first, then include the 
//      product name and version, and the word 'bug' in the subject.
//  
//  Complete, unaltered, original distributions of this and related code
//  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
//  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy

#include <types.h>
#include <vobject>
#include <vfile>

class vdirstream;
class vstream;
class vstat;


const class_t class_vdir = 0x00022000;


class vdir : public vobject {
public:
	virtual bool is_a(class_t c) const
		{ return (c == class_vdir) || vobject::is_a(c); }
	virtual vdirstream* opendir() const = 0;
	virtual bool _mkdir(const char *name) const;
	virtual const vobject* _get_object(const char *name) const;
	virtual const vfile* _get_file(const char *name) const;
	virtual const vdir* _get_dir(const char *name) const;
	virtual bool _stat(const char *name, vstat *vs) const;
	virtual vstream* _open(const char *name,
				int flags = vstream::READ) const;
	virtual vdirstream* _opendir(const char *name) const;
	virtual bool mkdir(const char *dname) const;
	virtual const vobject* get_object(const char *fname,
					const char *path = 0) const;
	virtual const vfile* get_file(const char *fname,
				      const char *path = 0) const;
	virtual const vdir* get_dir(const char *fname,
				      const char *path = 0) const;
	virtual bool stat(const char *fname, vstat *vs) const;
	virtual vstream* open(const char *fname, 
				int flags = vstream::READ) const;
	virtual vdirstream* opendir(const char *fname) const;
	virtual const vdir* dup() const = 0;
};

