//  vthread.C                                                   (CRC:85922b72)
//      relative path: ./lib/c++
//      creation date: Tue May 21 18:48:36 1996
//      last modified: Sat Oct 26 15:08:26 1996
//      header update: Sat Oct 26 15:08:27 1996
//  
//      Shag/OS: an Object-Oriented MicroKernel Operating System
//       Libraries
//        C++ specific code
//  
//  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
//  
//  This file is a part of the Shag/OS operating system distribution.
//  
//  Shag/OS is free software for non-profit uses; it may be freely distributed
//  for non-profit purposes under the terms of the Shag/OS License, version 1.
//  
//  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
//  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
//  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
//  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
//  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
//  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
//  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
//  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
//  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
//  
//  You should have received a copy of the Shag/OS License along with this
//  program, in a file called 'COPYING'.  If this license was not received,
//  please contact the author and describe how this software was obtained.
//  
//  The author can be reached for questions, comments, and suggestions at:
//  
//      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
//      email:   shaggy@csh.rit.edu
//  
//      For bug reports, please read the file 'BUGS' first, then include the 
//      product name and version, and the word 'bug' in the subject.
//  
//  Complete, unaltered, original distributions of this and related code
//  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
//  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy

#include <types.h>
#include <vtask>
#include "vthread.H"


vtask*
vthread::get_task() const
{ return task; }

const vdir* 
vthread::get_root() const
{ return get_task()->get_root(); }

const vdir*
vthread::get_cwd() const
{ return get_task()->get_cwd(); }

vstream*
vthread::get_stdin() const
{ return get_task()->get_stdin(); }

vstream*
vthread::get_stdout() const
{ return get_task()->get_stdout(); }

vstream*
vthread::get_stderr() const
{ return get_task()->get_stderr(); }

// XXX - should we provide some sort of exception handling for these?

bool
vthread::set_root(const vdir *)
{ return false; }

bool
vthread::set_cwd(const vdir *)
{ return false; }

bool
vthread::set_stdin(vstream *)
{ return false; }

bool
vthread::set_stdout(vstream *)
{ return false; }

bool
vthread::set_stderr(vstream *)
{ return false; }

vthread*
vthread::dup() const
{ return 0; }


