//  elftest.C                                                   (CRC:59572b86)
//      relative path: ./lib/elf
//      creation date: Fri Jan 26 17:08:03 1996
//      last modified: Sat Oct 26 15:08:53 1996
//      header update: Sat Oct 26 15:08:53 1996
//  
//      Shag/OS: an Object-Oriented MicroKernel Operating System
//       Libraries
//        Elf-format binary control
//  
//  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
//  
//  This file is a part of the Shag/OS operating system distribution.
//  
//  Shag/OS is free software for non-profit uses; it may be freely distributed
//  for non-profit purposes under the terms of the Shag/OS License, version 1.
//  
//  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
//  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
//  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
//  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
//  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
//  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
//  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
//  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
//  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
//  
//  You should have received a copy of the Shag/OS License along with this
//  program, in a file called 'COPYING'.  If this license was not received,
//  please contact the author and describe how this software was obtained.
//  
//  The author can be reached for questions, comments, and suggestions at:
//  
//      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
//      email:   shaggy@csh.rit.edu
//  
//      For bug reports, please read the file 'BUGS' first, then include the 
//      product name and version, and the word 'bug' in the subject.
//  
//  Complete, unaltered, original distributions of this and related code
//  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
//  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy

#pragma Make Includes_Banned += -nostdinc -nostdinc++

#include <stdio.h>
#include "File.h"
#include "Elf32.h"



void blap()
{
	printf("this is blap\n");
}


main(int /*argc*/, char **argv)
{
Elf32 elf(argv[1]);
Elf32::link_info mainlink(0, _DYNAMIC, true);
Elf32::link_info *linkp;
	printf("debug=%p dyn=%p\n", mainlink.debug, _DYNAMIC);
	printf("v=%d brk=%lx s=%x ld=%lx\n",
		mainlink.debug->r_version,
		mainlink.debug->r_brk,
		mainlink.debug->r_state,
		mainlink.debug->r_ldbase);

	linkp = mainlink.debug->r_map;
	mainlink.libname = "_System_";
	elf.attach(&mainlink);
	while(linkp) {
		printf("link: %p\n", linkp);
		printf("l:%p, d:%p n:%s\n", (void*)(linkp->loadaddr),
			linkp->dynamic_addr, linkp->libname);
		printf("prev=%p next=%p\n", linkp->prev, linkp->next);
		Elf32::link_info *link 
				= new Elf32::link_info(linkp->loadaddr,
					linkp->dynamic_addr, true);
		elf.attach(link);
		linkp = linkp->next;
	}
	elf.dump();
	elf.exec();
}

