/*  8742kb.h                                                    (CRC:8abfa73a)
 *      relative path: ./lib/hw
 *      creation date: Jan 1995
 *      last modified: Sun Sep 22 18:30:56 1996
 *      header update: Sat Oct 26 15:08:39 1996
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Hardware-specific
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution.
 *  
 *  Shag/OS is free software for non-profit uses; it may be freely distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'COPYING'.  If this license was not received,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For bug reports, please read the file 'BUGS' first, then include the 
 *      product name and version, and the word 'bug' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

//	8042/8741/8742 KeyBoard controller



#define KB_OUTPUT		0x0	// Read 
#define KB_INPUT		0x0	// Write 
#define	KB_CTRL			0x4	// Write 
#define KB_STATUS		0x4	// Read 
#define KB_SIZEOF		0x8	// ???

#define 	KB_STATUS_OUT_RDY	0x01	// data in output buffer
#define 	KB_STATUS_IN_RDY	0x02	// data in output buffer
#define 	KB_STATUS_SELFTEST	0x04	// self test okay
#define 	KB_STATUS_CMD		0x08	// command written via 0x64
#define		KB_STATUS_KBFREE	0x10	// not locked
#define		KB_STATUS_AUX		0x20	// output buffer from aux
#define		KB_STATUS_TIMEOUT	0x40	// general timeout
#define		KB_STATUS_PARITY	0x80	// parity error


#define KB_CTRL_AUX_DISABLE	0xa7	// disable auxiliary device 
#define KB_CTRL_AUX_ENABLE	0xa8	// enable auxiliary device 
#define KB_CTRL_CHECK_AUX	0xa9	// check interface to auxiliary device
#define KB_CTRL_READ_INPUT	0xc0	// transfers input port into output buffer
#define KB_CTRL_READOUT_LOW	0xc1	// repeatedly read 0-3 into status 4-7 
#define KB_CTRL_READOUT_HIGH	0xc2	// repeatedly read 4-7 into status 4-7 
#define KB_CTRL_READ_OUTPUT	0xd0	// transfers output port into output buffer 
#define KB_CTRL_WRITE_OUTPUT	0xd1	// write next byte into output port 
#define KB_CTRL_WRITE_OUTBUF	0xd2	// write next byte into output buffer 
#define KB_CTRL_WRITE_AUX	0xd3	// write aux device output buffer 
#define KB_CTRL_PULSE_RESET	0xfe	// pulse the system reset line 

// also need:	0xaa, 0xab, 0xad, 0xae, 0xc0, 0xc1, 0xc2, 0xd0, 0xd1, 0xd2, 0xd3, 0xd4
//		0xe0, 0xf0-0xff 


#define KB_CMD_LED		0xed	// turn on/off LED's
#define 	KB_LED_SCRL	0x01 	// scroll lock LED
#define 	KB_LED_NUML	0x02 	// num lock LED
#define 	KB_LED_CAPS	0x04 	// caps lock LED
#define KB_CMD_ECHO		0xee	// send back 0xee
#define KB_CMD_SETSCAN		0xf0	// set scan code set and get present set
#define KB_CMD_ID		0xf2	// return keyboard ID
#define KB_CMD_SETRATE		0xf3	// set repitition rate and delay
#define		KB_RATE_250MS	0x00	// 250 ms delay
#define		KB_RATE_500MS	0x20	// 500 ms delay
#define		KB_RATE_750MS	0x40	// 750 ms delay
#define		KB_RATE_1000MS	0x60	// 1000 ms delay
#define		KB_RATE_30CPS	0x00	// 30 chars/sec
#define		KB_RATE_11CPS	0x0b	// 11 chars/sec
#define		KB_RATE_2CPS	0x1f	// 2 chars/sec
#define KB_CMD_ENABLE		0xf4	// enable keyboard
#define KB_CMD_STAND_DIS	0xf5	// sets standard values and disables KB
#define KB_CMD_STAND_DIS2	0xf6	// alternative STAND_DIS command
#define KB_CMD_RESEND		0xfe	// retransmit last character
#define KB_CMD_RESET		0xff	// execute an internal keyboard reset


#define KB_INPUT_KBLOCK		0x80
#define KB_INPUT_MONO		0x40
#define KB_INPUT_AUXD		0x02
#define KB_INPUT_KBDI		0x01

#define KB_OUTPUT_KBDO		0x80
#define	KB_OUTPUT_KCLK		0x40
#define KB_OUTPUT_AUXB		0x20
#define KB_OUTPUT_OUTB		0x10
#define KB_OUTPUT_ACLK		0x08
#define KB_OUTPUT_AXDO		0x04
#define KB_OUTPUT_GA20		0x02
#define KB_OUTPUT_SYSR		0x01
#define KB_OUTPUT_A20_ON	0xdf
#define KB_OUTPUT_A20_OFF	0xdd

#define KB_ACK			0xfa	
#define	KB_OVERFLOW		0x00
#define	KB_KEYERR		0xff
#define KB_BAT_COMPLETE		0xaa
#define KB_BAT_ERROR		0xfc
#define KB_RESEND		0xfe

