/*  Register.h                                                  (CRC:3a328622)
 *      Register access through ports
 *      
 *      relative path: ./lib/hw/m-i386
 *      creation date: Dec 1994
 *      last modified: Sat Sep 28 15:16:47 1996
 *      header update: Sat Oct 26 15:08:32 1996
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Hardware-specific
 *         (m-i386)
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution.
 *  
 *  Shag/OS is free software for non-profit uses; it may be freely distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'COPYING'.  If this license was not received,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For bug reports, please read the file 'BUGS' first, then include the 
 *      product name and version, and the word 'bug' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#include <types.h>


// XXX - needs I/O delays
// also should be support indexing
// this class should NOT be used as it is...
// the eventual intention (given time)
// is to support something like:
//	Register8 reg(0x70);
//	reg[12] = 56;	// this does outb(12,0x70) outb(56,0x71)

class Register {
	uint16	base;
public:
	Register()			{ base = 0; }
	Register(uint16 n)		{ base = n; }
	void operator=(uint16 n)	{ base = n; }
	uint8	inb(uint8 r) {
			volatile uint8 v;
			asm("outb %%al,%%dx; incw %%dx; inb %%dx,%%al"
				:"a="(v):"d"(base),"a"(r));
			return v; }
	uint16	inw(uint8 r) {
			volatile uint16 v;
			asm("movb %%al,%%ah; incb %%ah; outb %%al,%%dx;"
				"incw %%dx; inb %%dx,%%al; movb %%al,%%ch;"
				"decw %%dx; movb %%ah,%%al; outb %%al,%%dx;"
				"incw %%dx; inb %%dx,%%al; movb %%al,%%cl"
				:"c="(v):"d"(base),"a"(r));
			return v; }
	void	outb(uint8 v, uint8 r) {
			asm("outb %%al,%%dx; movb %0,%%al; incw %%dx;"
				"outb %%al,%%dx": :"g"(v),"a"(r),"d"(base)); }
	void	outw(uint16 v, uint8 r) {
			asm("movb %%al,%%ah; incb %%ah; outb %%al,%%dx;"
				"movb %%ch,%%al; incw %%dx; outb %%al,%%dx;"
				"movb %%ah,%%al; decw %%dx; outb %%al,%%dx;"
				"movb %%cl,%%al; incw %%dx; outb %%al,%%dx"
				: :"c"(v),"a"(r),"d"(base)); }
};


