/*  cmos.h                                                      (CRC:ade2ac3d)
 *      relative path: ./lib/hw/m-pc
 *      creation date: Sun Sep 22 19:43:00 1996
 *      last modified: Sun Sep 22 19:43:00 1996
 *      header update: Sat Oct 26 15:08:40 1996
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Hardware-specific
 *         (m-pc)
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution.
 *  
 *  Shag/OS is free software for non-profit uses; it may be freely distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'COPYING'.  If this license was not received,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For bug reports, please read the file 'BUGS' first, then include the 
 *      product name and version, and the word 'bug' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*  cmos.h
 *	CMOS Memory Addresses
 *
 *      relative path: lib/hw
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Hardware-specific
 *  
 *  Copyright (C) 1994-1996	Frank E. Barrus
 *  
 *  This file is a part of the Shag/OS operating system distribution.
 *  
 *  Shag/OS is free software, for non-profit uses; it may be freely distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 0.
 *  This software comes with absolutely no warranty, expressed or implied.
 *  
 *  You should have received a copy of version 0 of the Shag/OS License along
 *  with this program, in a file called 'COPYING'.  If you did not receive this
 *  license, please contact the author and describe how this file was received.
 *  
 *  The author can be reached for questions, comments,
 *  suggestions, and bug-reports at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 *  
 */


#define CMOS_ADDR	0x0
#define CMOS_DATA	0x1
#define CMOS_EXT_LO	0x4
#define CMOS_EXT_HI	0x5
#define CMOS_EXT_DATA	0x6
#define CMOS_SIZEOF	0x8

#define CMOS_SECOND		0x00
#define CMOS_ALARM_SECOND	0x01
#define CMOS_MINUTE		0x02
#define CMOS_ALARM_MINUTE	0x03
#define CMOS_HOUR		0x04
#define CMOS_ALARM_HOUR		0x05
#define CMOS_DAY_OF_WEEK	0x06
#define CMOS_DAY_OF_MONTH	0x07
#define CMOS_MONTH		0x08
#define CMOS_YEAR		0x09
#define CMOS_STATUS_A		0x0a
#define CMOS_STATUS_B		0x0b
#define CMOS_STATUS_C		0x0c
#define CMOS_STATUS_D		0x0d

#define CMOS_DIAG		0x0e
#define CMOS_SHUTDOWN		0x0f
#define		CMOS_SHUTDOWN_NORMAL		0x00
#define		CMOS_SHUTDOWN_INIT_REAL		0x01
#define		CMOS_SHUTDOWN_JMP_BOOT		0x04
#define		CMOS_SHUTDOWN_EOI_JMP_40_67	0x05
#define		CMOS_SHUTDOWN_JMP_40_67		0x06	// also 0x0a
#define		CMOS_SHUTDOWN_MOVE_BLOCK	0x07	// also 0x09
#define		CMOS_SHUTDOWN_POST_MEMTEST	0x08
#define		CMOS_SHUTDOWN_IRET_40_67	0x0b
#define		CMOS_SHUTDOWN_RETF_40_67	0x0c
#define CMOS_FLOPPY_TYPES	0x10
#define CMOS_HARD_TYPES		0x12

/* XXX - and lots of other things to be filled in later
 */

