/*  btypes.h                                                    (CRC:6935249d)
 *      relative path: ./lib/m-pc
 *      creation date: Dec 1994
 *      last modified: Sat Oct 26 15:08:44 1996
 *      header update: Sat Oct 26 15:08:45 1996
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        (m-pc)
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution.
 *  
 *  Shag/OS is free software for non-profit uses; it may be freely distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'COPYING'.  If this license was not received,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For bug reports, please read the file 'BUGS' first, then include the 
 *      product name and version, and the word 'bug' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

/*	basic type definitions for an Intel-based PC
 */
 

#ifndef ASM

typedef unsigned char		uint8;
typedef unsigned short int	uint16;
typedef unsigned int 		uint32;
typedef unsigned long long int	uint64;

typedef signed char		int8;
typedef signed short int	int16;
typedef signed int		int32;
typedef signed long long int	int64;


/* for these addressing types,	16 bits would limit to 64K max memory 
 *				(for small embedded systems)
 *				32 bits limits to 4Gb
 *				(for all other systems)
 *				64 bits is wasted for PC machines
 */
typedef uint32	vaddr_t;	/* virtual addresses (32) */
typedef int32	svaddr_t;	/* signed virtual addresses (32) */
typedef uint32	paddr_t;	/* physical addresses (16/32) */

/* for these page number types, 8 bits limits to 1Mb (for small machines)
 *				16 bits limits to 256Mb (most machines)
 *				32 bits limits to 16Tb (excessive)
 */
typedef uint16	vpage_t;	/* virtual page numbers (16/32) */
typedef uint16	ppage_t;	/* physical page numbers (8/16/32) */

typedef uint16	ref_t;		/* 64K max references */


#endif

