/*  macro.h                                                     (CRC:c49c8f2c)
 *      relative path: ./lib
 *      creation date: Dec 1994
 *      last modified: Sat Oct  5 15:19:04 1996
 *      header update: Sat Oct 26 15:08:46 1996
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution.
 *  
 *  Shag/OS is free software for non-profit uses; it may be freely distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'COPYING'.  If this license was not received,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For bug reports, please read the file 'BUGS' first, then include the 
 *      product name and version, and the word 'bug' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#ifndef __GLOBAL__
#define __GLOBAL__ extern
#endif

#define bit(x)		(1 << (x))	

#define ctrl(c)		((c)-64)	

#define align(adr, n)		(((adr)+(n)-1) & ~((n)-1))
#define align_down(adr, n)	((adr) & ~((n)-1))
#define align_div(adr, n)	(((adr)+(n)-1)/(n))

#define is_pow2(n)	(!((n) & ((n)-1))

#define abs(x)		(((x) < 0) ? (-(x)) : (x))
#define min(x,y)	(((x) < (y)) ? (x) : (y))
#define max(x,y)	(((x) > (y)) ? (x) : (y))

#define QUOTE(n)	__quote_(n)
#define __quote_(x)	#x

/*
#define ADR_LEN(d)	&d, sizeof(d)
#define CSTR_LEN(t,v)	(t)(v), sizeof(v)-1
#define DSTR_LEN(t,v)	(t)(v), strlen(v)
*/

#define range_min(v,min)	 { if((v) < (min)) (v) = (min); }
#define range_max(v,max)	 { if((v) > (max)) (v) = (max); }
#define range_min_max(v,min,max) { if((v) < (min)) (v) = (min); \
				   if((v) > (max)) (v) = (max); }

/*
#define KMALLOC(type)	(type*)(kmalloc(sizeof(type)))
#define KFREE(x)	kfree(x);
#define MALLOC(type)	(type*)(malloc(sizeof(type)))
#define FREE(x)		free(x);

inline alignment functions:
static inline uint align(uint n, uint a = 4) { return ((n-1)&~(a-1))+a; }
static inline uint round(uint n, uint a = 4) { return n&~(a-1); }
*/

