//  Lexer.C                                                     (CRC: 4fbf908)
//      relative path: ./lib/parse
//      creation date: Mon Mar  4 00:48:00 1996
//      last modified: Sat Oct 26 15:10:04 1996
//      header update: Sat Oct 26 15:10:04 1996
//  
//      Shag/OS: an Object-Oriented MicroKernel Operating System
//       Libraries
//        Generic parsing functions
//  
//  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
//  
//  This file is a part of the Shag/OS operating system distribution.
//  
//  Shag/OS is free software for non-profit uses; it may be freely distributed
//  for non-profit purposes under the terms of the Shag/OS License, version 1.
//  
//  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
//  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
//  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
//  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
//  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
//  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
//  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
//  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
//  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
//  
//  You should have received a copy of the Shag/OS License along with this
//  program, in a file called 'COPYING'.  If this license was not received,
//  please contact the author and describe how this software was obtained.
//  
//  The author can be reached for questions, comments, and suggestions at:
//  
//      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
//      email:   shaggy@csh.rit.edu
//  
//      For bug reports, please read the file 'BUGS' first, then include the 
//      product name and version, and the word 'bug' in the subject.
//  
//  Complete, unaltered, original distributions of this and related code
//  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
//  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy

#define IMPLEMENTATION_Lexer
#include <Lexer>


Lexer::Lexer()
{
	if(init_ctypes) {
		for(int i=0; i<256; i++) {
			int ct = 0;
			switch(i) {
			case ' ': case '\r': case '\n': case '\t':
			case '\f': case '\v':
				ct |= WHITESPACE; break;
			case 'A' ... 'F': ct |= HEXNUM;
			case 'G' ... 'Z': ct |= UPPER | ID | ID_START; break;
			case 'a' ... 'f': ct |= HEXNUM;
			case 'g' ... 'z': ct |= LOWER | ID | ID_START; break;
			case '0' ... '1': ct |= BINNUM;
			case '2' ... '7': ct |= OCTNUM;
			case '8' ... '9': ct |= NUM | HEXNUM | ID; break;
			case '$': case '_':	ct |= ID | ID_START; break;
			default:
				if(i >= 32 && i <= 126)
					ct |= PUNC;
			}
			ctype[i] = (ctypes)ct;
		}
	}	
	set_empty();
	_sol = true;
	_line_num = 1;
}

