/*  errno.h                                                     (CRC:d2e1c812)
 *      relative path: ./lib/posix
 *      creation date: 1992
 *      last modified: Sat Oct 26 15:09:18 1996
 *      header update: Sat Oct 26 15:09:19 1996
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Posix-complient code
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution.
 *  
 *  Shag/OS is free software for non-profit uses; it may be freely distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'COPYING'.  If this license was not received,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For bug reports, please read the file 'BUGS' first, then include the 
 *      product name and version, and the word 'bug' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#include <posix/posix.h>
#include <posix/sys/types.h>

#if 0

#include <object.h>

#define E2BIG		ObjErr(0x100)
#define EACCES		ObjErr(0x101)
#define EAGAIN		ObjErr(0x102)
#define EBADF		ObjErr(0x103)
#define EBUSY		ObjErr(0x104)
#define ECHILD		ObjErr(0x105)
#define EDEADLK		ObjErr(0x106)
#define EDOM		ObjErr(0x107)
#define EEXIST		ObjErr(0x108)
#define EFAULT		ObjErr(0x109)
#define EFBIG		ObjErr(0x10a)
#define EINTR		ObjErr(0x10b)
#define EINVAL		ObjErr(0x10c)
#define EIO		ObjErr(0x10d)
#define EISDIR		ObjErr(0x10e)
#define EMFILE		ObjErr(0x10f)
#define EMLINK		ObjErr(0x110)
#define ENAMETOOLONG	ObjErr(0x111)
#define ENFILE		ObjErr(0x112)
#define ENODEV		ObjErr(0x113)
#define ENOENT		ObjErr(0x114)
#define ENOEXEC		ObjErr(0x115)
#define ENOLCK		ObjErr(0x116)
#define ENOMEM		ObjErr(0x117)
#define ENOSPC		ObjErr(0x118)
#define ENOSYS		ObjErr(0x119)
#define ENOTDIR		ObjErr(0x11a)
#define ENOTEMPTY	ObjErr(0x11b)
#define ENOTTY		ObjErr(0x11c)
#define ENXIO		ObjErr(0x11d)
#define EPERM		ObjErr(0x11e)
#define EPIPE		ObjErr(0x11f)
#define ERANGE		ObjErr(0x120)
#define EROFS		ObjErr(0x121)
#define ESPIPE		ObjErr(0x122)
#define ESRCH		ObjErr(0x123)
#define EXDEV		ObjErr(0x124)

#endif

