/*  fcntl.h                                                     (CRC:7aad3141)
 *      relative path: ./lib/posix
 *      creation date: 1992
 *      last modified: Fri Oct 18 19:28:51 1996
 *      header update: Sat Oct 26 15:09:18 1996
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Posix-complient code
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution.
 *  
 *  Shag/OS is free software for non-profit uses; it may be freely distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'COPYING'.  If this license was not received,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For bug reports, please read the file 'BUGS' first, then include the 
 *      product name and version, and the word 'bug' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#include <posix/posix.h>
#include <posix/sys/types.h>

#define O_ACCMODE	0x03
#define O_RDONLY	0x00
#define O_WRONLY	0x01
#define	O_RDWR		0x02
#define	O_CREAT		0x04
#define O_TRUNC		0x08
#define O_APPEND	0x10	
#define O_EXCL		0x20
#define O_NOCTTY	0x40
#define O_NONBLOCK	0x80

#define FD_CLOEXEC	XXX
#define F_DUPFD		XXX
#define F_GETFD		XXX
#define F_GETFL		XXX
#define F_GETLK		XXX
#define F_RDLCK		XXX
#define F_SETFD		XXX
#define F_SETFL		XXX
#define F_SETLK		XXX
#define F_SETLKW	XXX
#define F_UNLCK		XXX
#define F_WRLCK		XXX

#define SEEK_SET	0
#define SEEK_CUR	1
#define SEEK_END	2


struct flock {
	short	l_type;
	short	l_whence;
	off_t	l_start;
	off_t	l_len;
	pid_t	l_pid;
};


/*
extern_C obj_t open(char *path, int oflag, ...);
extern_C obj_t creat(char *path, int mode);
extern_C status_t close(obj_t fd);
extern_C off_t lseek(obj_t fd, off_t offset, int whence);
extern_C obj_t dup(obj_t fd);
extern_C obj_t dup2(obj_t fd, obj_t fd2);
extern_C obj_t fcntl(obj_t fd, int cmd, ...);
*/

