//  $Id: string.C,v 1.2 1996/10/26 19:09:32 shaggy Exp $
//      string operations optimized for i386
//      
//      relative path: ./lib/posix/m-i386
//  
//      Shag/OS: an Object-Oriented MicroKernel Operating System
//       Libraries
//        Posix-complient code
//         (m-i386)
//  
//  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
//  
//  This file is a part of the Shag/OS operating system distribution.
//  
//  Shag/OS is free software for non-profit uses; it may be freely distributed
//  for non-profit purposes under the terms of the Shag/OS License, version 1.
//  
//  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
//  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
//  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
//  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
//  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
//  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
//  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
//  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
//  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
//  
//  You should have received a copy of the Shag/OS License along with this
//  program, in a file called 'COPYING'.  If this license was not received,
//  please contact the author and describe how this software was obtained.
//  
//  The author can be reached for questions, comments, and suggestions at:
//  
//      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
//      email:   shaggy@csh.rit.edu
//  
//      For bug reports, please read the file 'BUGS' first, then include the 
//      product name and version, and the word 'bug' in the subject.
//  
//  Complete, unaltered, original distributions of this and related code
//  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
//  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy

//  $Log: string.C,v $
//  Revision 1.2  1996/10/26  19:09:32  shaggy
//  header update
//
//  Revision 1.1  1996/10/06  13:45:29  shaggy
//  Initial revision
//
//      last modified: Wed May 22 18:27:33 1996
//      creation date: Dec 1994


#pragma Make Flags_Banned += -pedantic

#ifndef FUNC_memcpy
#define FUNC_memcpy
#ifndef MACH_i386sx	/* attempt to move longwords */
/* void memcpy(char *dest, char *src, int size) */
asm("
.globl memcpy	
memcpy:
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%esi	
	pushl	%edi
	movl	8(%ebp),%edi
	movl	12(%ebp),%esi
	movl	16(%ebp),%ecx
	cmpl	$0,%ecx		/* leave if done */
	je	3f
1:	test	$3,%edi		/* align dest to longword boundary */
	jz	2f						
	movsb	(%esi),(%edi)	/* copy a byte */	
	loop	1b				
	jmp	3f			
2:	cmpl	$0,%ecx		/* leave if done */
	je	3f		 			
	movl	%ecx,%edx			
	shrl	$2,%ecx		/* number of longwords */
	andl	$3,%edx		/* number of bytes remainder */
	rep	
	movsl	(%esi),(%edi)	/* copy longwords */	
	cmpl	$0,%edx		/* leave if done */
	je	3f		
	movl	%edx,%ecx	/* get remainder */	
	rep	
	movsb	(%esi),(%edi)	/* copy bytes */
3:	popl	%edi	
	popl	%esi	
	leave		
	ret	
");
#else		/* 16-bit bus -- move shorts only */
/* void memcpy(char *dest, char *src, int size) */
asm("
.globl memcpy
memcpy:
	pushl	%ebp				
	movl	%esp,%ebp			
	pushl	%esi			
	pushl	%edi		
	movl	8(%ebp),%edi
	movl	12(%ebp),%esi
	movl	16(%ebp),%ecx		
	cmpl	$0,%ecx		/* leave if done */
	je	3f
1:	test	$1,%edi		/* align dest to word boundary */
	jz	2f
	movsb	(%esi),(%edi)	/* copy a byte */
	dec	%ecx	
2:	cmpl	$0,%ecx		/* leave if done */
	je	3f		
	movl	%ecx,%edx	
	shrl	$1,%ecx		/* number of longwords */
	rep		
	movsw	(%esi),(%edi)	/* copy words */
	test	$1,%edx		/* check remainder */	
	jz	3f	
	movsb	(%esi),(%edi)	/* copy leftover byte */
3:	popl	%edi	
	popl	%esi
	leave	
	ret
");
#endif
#endif



#ifndef FUNC_memset
#define FUNC_memset
/* void memset(char *dest, uchar data, int nbytes) */
asm("
.globl memset	
memset:
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%edi		
	movl	8(%ebp),%edi	
	movl	16(%ebp),%ecx
	movl	12(%ebp),%eax
	cmpl	$0,%ecx	
	je	1f
	rep	
	stosb	
1:	popl	%edi	
	leave
	ret
");
#endif

#ifndef FUNC_memset_w
#define FUNC_memset_w
/* void memset_w(char *dest, ushort data, int nwords) */
asm("
.globl memset_w
memset_w:
	pushl	%ebp	
	movl	%esp,%ebp	
	pushl	%edi	
	movl	8(%ebp),%edi
	movl	16(%ebp),%ecx	
	movl	12(%ebp),%eax
	cmpl	$0,%ecx	
	je	1f
	rep	
	stosw
1:	popl	%edi
	leave
	ret
");
#endif

#ifndef FUNC_memset_l
#define FUNC_memset_l
/* void memset_l(char *dest, int nwords, ulong data) */
asm("
.globl memset_l
memset_l:
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%edi	
	movl	8(%ebp),%edi
	movl	16(%ebp),%ecx	
	movl	12(%ebp),%eax
	cmpl	$0,%ecx	
	je	1f
	rep	
	stosl
1:	popl	%edi
	leave
	ret
");
#endif


#ifndef FUNC_strcpy
#define FUNC_strcpy
asm("
.globl strcpy	
strcpy:
	pushl	%ebp
	movl	%esp,%ebp
	pushl	%edi
	pushl	%esi	
	movl	8(%ebp),%edi
	movl	12(%ebp),%esi
1:	lodsb
	stosb	
	cmpb	$0,%al
	jnz	1b
	mov	12(%ebp),%eax
	popl	%esi
	popl	%edi
	leave
	ret
");
#endif

#ifndef FUNC_strcat
#define FUNC_strcat
asm("
.globl strcat	
strcat:
	pushl	%ebp	
	movl	%esp,%ebp
	pushl	%edi	
	pushl	%esi	
	movl	8(%ebp),%esi
1:	lodsb	
	cmpb	$0,%al	
	jnz	1b
	leal	-1(%esi),%edi
	movl	12(%ebp),%esi
1:	lodsb	
	stosb
	cmpb	$0,%al	
	jnz	1b
	mov	8(%ebp),%eax
	popl	%esi
	popl	%edi
	leave	
	ret
");
#endif

#ifndef FUNC_strlen
#define FUNC_strlen
asm("
.globl strlen	
strlen:	
	pushl	%ebp	
	movl	%esp,%ebp
	pushl	%esi		
	movl	8(%ebp),%esi
1:	lodsb		
	cmpb	$0,%al
	jnz	1b
	movl	%esi,%eax	
	subl	8(%ebp),%eax
	decl	%eax	
	popl	%esi
	leave	
	ret	
");
#endif

