/*  string.h                                                    (CRC:d462b87c)
 *      relative path: ./lib/posix
 *      creation date: 1992
 *      last modified: Sat Oct 26 15:09:23 1996
 *      header update: Sat Oct 26 15:09:23 1996
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *        Posix-complient code
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution.
 *  
 *  Shag/OS is free software for non-profit uses; it may be freely distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'COPYING'.  If this license was not received,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For bug reports, please read the file 'BUGS' first, then include the 
 *      product name and version, and the word 'bug' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#include <posix/posix.h>
#include <posix/sys/types.h>
#include <posix/stddef.h> 


extern_C void *memchr(const void *s, int c, size_t n);
extern_C int memcmp(const void *s1, const void *s2, size_t n);
extern_C void *memcpy(void *s1, const void *s2, size_t n);
extern_C void *memmove(void *s1, const void *s2, size_t n);
extern_C void *memset(void *s, uchar c, size_t n);
extern_C void *memset_w(void *s, ushort c, size_t n);
extern_C void *memset_l(void *s, ulong c, size_t n);
extern_C char *strcat(char *s1, const char *s2);
extern_C char *strchr(const char *s, int c);
extern_C int strcmp(const char *s1, const char *s2);
extern_C int strcoll(const char *s1, const char *s2);
extern_C char *strcpy(char *s1, const char *s2);
extern_C size_t strcspn(const char *s1, const char *s2);
extern_C char *strerror(ulong errnum);
extern_C size_t strlen(const char *s);
extern_C char *strncat(char *s1, const char *s2, size_t n);
extern_C int strncmp(const char *s1, const char *s2, size_t n);
extern_C char *strncpy(char *s1, const char *s2, size_t n);
extern_C char *strpbrk(const char *s1, const char *s2);
extern_C char *strrchr(const char *s, int c);
extern_C size_t strspn(const char *s1, const char *s2);
extern_C char *strstr(const char *s1, const char *s2);
extern_C char *strtok(char *s1, const char *s2);
extern_C size_t strxfrm(char *s1, const char *s2, size_t n);

