/*  types.h                                                     (CRC:5437af5f)
 *      relative path: ./lib
 *      creation date: Dec 1994
 *      last modified: Sat Oct 26 15:09:36 1996
 *      header update: Sat Oct 26 15:09:37 1996
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       Libraries
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution.
 *  
 *  Shag/OS is free software for non-profit uses; it may be freely distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'COPYING'.  If this license was not received,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For bug reports, please read the file 'BUGS' first, then include the 
 *      product name and version, and the word 'bug' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#include <btypes.h>

#ifndef ASM

#ifndef USE_STDLIB

#if !defined(__cplusplus) || defined(need_wchar_t)
typedef ushort		wchar_t;
#endif

#ifndef _TIME_T
#define _TIME_T
typedef int64 time_t;		// in nanoseconds, starting at the epoch,
				// midnight Jan 1, 1970
#endif

#define	SEC	(time_t)1000000000	// one second in nanoseconds
#define MSEC	(time_t)1000000		// one millisecond
#define USEC	(time_t)1000		// one microsecond
#define NSEC	(time_t)1		// one nanosecond

#ifndef _PTRDIFF_T
#define _PTRDIFF_T
typedef vaddr_t	ptrdiff_t;
#endif

#ifndef _SIZE_T
#define _SIZE_T
typedef	vaddr_t	size_t;
#endif

#ifndef _SSIZE_T
#define _SSIZE_T
typedef svaddr_t ssize_t;
#endif

#ifndef _COUNT_T
#define _COUNT_T
typedef int32	count_t;
#endif

#ifndef _WINT_T
#define _WINT_T
typedef wchar_t	wint_t;
#endif

#ifndef NULL
#ifdef __cplusplus
#define NULL		0
#else
#define NULL		(void*)0
#endif
#endif

#ifndef NULLP
#define NULLP(t)	(t*)0
#endif

#endif 	/* USE_STDLIB */
#endif	/* ASM */

