/*  ArgParse.h                                                  (CRC:10dc3d83)
 *      relative path: ./sys/boot
 *      creation date: Sun Oct 29 11:03:18 1995
 *      last modified: Sat Oct 26 15:11:39 1996
 *      header update: Sat Oct 26 15:11:41 1996
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       System files
 *        Boot loader
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution.
 *  
 *  Shag/OS is free software for non-profit uses; it may be freely distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'COPYING'.  If this license was not received,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For bug reports, please read the file 'BUGS' first, then include the 
 *      product name and version, and the word 'bug' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

// ArgParse

#include <stddef.h>
#include <strclass.h>

class ArgParse {
	int	_argc;
	char**	_argv;
	bool	_quit;
	int	_num;
public:
	ArgParse(int argc, char** argv)
		{ _argc = argc; _argv = argv; _quit = true; _num = 1; }
	bool match(char *s, bool *set = 0);
	bool match(char *s, string *str);
	bool prefix(char *s, bool *set = 0);
	bool prefix(char *s, string *str);
	bool flag(char f, bool *set = 0);
	bool get(string *str);
	void badoption();
	void badflag();
	void missing();
	bool more()		{ return _num < _argc; }
	bool last()		{ return _num == _argc - 1; }
};

