/*  bios.h                                                      (CRC:23beacf6)
 *      various definitions for BIOS memory and function access
 *      
 *      relative path: ./sys/boot/m-pc
 *      creation date: December 1994
 *      last modified: Sat Oct 26 15:11:09 1996
 *      header update: Sat Oct 26 15:11:09 1996
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       System files
 *        Boot loader
 *         (m-pc)
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution.
 *  
 *  Shag/OS is free software for non-profit uses; it may be freely distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'COPYING'.  If this license was not received,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For bug reports, please read the file 'BUGS' first, then include the 
 *      product name and version, and the word 'bug' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#define BIOS_SEG	0x40			// BIOS data segment
#define BIOS_DATA	0x400			// absolute start

#define BIOS_KEY_NEXT	0x41a			// next char in buf
#define BIOS_KEY_AVAIL	0x41c			// end of buf + 1
#define BIOS_KEY_BUF	0x41e			// keyboard buffer
#define BIOS_KEY_BUFEND	0x43e			// one past end

#define BIOS_VID_MODE	0x449			// current video mode
#define BIOS_VID_WID	0x44a			// screen width
#define BIOS_VID_HGT	0x484			// screen height
#define BIOS_VID_X	0x450			// current column
#define BIOS_VID_Y	0x451			// current row
#define BIOS_VID_PAGE	0x462			// current page

#define BIOS_RESET_VEC	0x467			// reset vector
#define BIOS_RESET_FLAG	0x472			// reset flag
#define BIOS_RESET_FLAG_SAVE	0x4321		// preserve memory
#define BIOS_RESET_FLAG_WARM	0x1234		// warm boot
#define BIOS_RESET_FLAG_COLD	0x0000		// cold boot
#define BIOS_RESET_FLAG_BURN	0x0064		// burn-in mode

