/*  debug.h                                                     (CRC:d4342b3e)
 *      relative path: ./sys/boot/m-pc
 *      creation date: Sun Jul 28 11:22:34 1996
 *      last modified: Sat Oct 26 15:11:33 1996
 *      header update: Sat Oct 26 15:11:33 1996
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       System files
 *        Boot loader
 *         (m-pc)
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution.
 *  
 *  Shag/OS is free software for non-profit uses; it may be freely distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'COPYING'.  If this license was not received,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For bug reports, please read the file 'BUGS' first, then include the 
 *      product name and version, and the word 'bug' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

#include "macro.h"


.globl	dumpreg, dumpreg_at
.globl	puts
.globl	getchar


#ifdef DEBUG

#if 0
#define _DUMPREG(s)	\
		pushf				_NL \
		push	bx			_NL \
		mov	bx,_POUND s##_msg	_NL \
		call	puts 			_NL \
		pop	bx			_NL \
		popf				_NL \
		jmp	s##_jmp			_NL \
	s##_msg: .ascii #s 			_NL \
		.byte	10,0			_NL \
	s##_jmp: call	dumpreg			_NL \
		pushf				_NL \
		push	ax			_NL \
		call	getchar			_NL \
		pop	ax			_NL \
		popf		
#else

#define _DUMPREG(s)	\
	.text					_NL \
		push	_POUND s##_msg		_NL \
		call	debug_dumpreg		_NL \
	.data					_NL \
	s##_msg: .ascii	#s			_NL \
		.byte	0			_NL \
	.text					
#endif

.data
debug_dumpreg:
	pushf
	push	bx
	push	ds
	xor	bx,bx
	mov	ds,bx		// ds = 0
	mov	bx,sp
	mov	bx,8(bx)	// bx -> string
	call	puts
#ifdef __BASE_FILE__
	mov	bx,#basefile
	call	puts
#else
	call	putnl
#endif
	pop	ds
	pop	bx
	popf
	pushf			// get back the flags
	push	#2		// how far down stack the PC is
	push	#4		// amount to adjust SP by
	call	dumpreg_at	// arguments are popped off afterwards
	push	ax
	call	getchar
	pop	ax
	popf
	ret	#2


#ifdef __BASE_FILE__
basefile:
	.ascii	" in "
	.ascii	__BASE_FILE__
	.byte	10, 0
.text
#endif


#define _PROGRESS(x)		mov word PROGRESS,_POUND x

#else

#define _DUMPREG(s)
#define _PROGRESS(x)

#endif

