/*  devio.h                                                     (CRC: 61fe872)
 *      relative path: ./sys/boot/m-pc
 *      creation date: Sat Jul 27 11:42:10 1996
 *      last modified: Sat Oct 26 15:11:28 1996
 *      header update: Sat Oct 26 15:11:29 1996
 *  
 *      Shag/OS: an Object-Oriented MicroKernel Operating System
 *       System files
 *        Boot loader
 *         (m-pc)
 *  
 *  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
 *  
 *  This file is a part of the Shag/OS operating system distribution.
 *  
 *  Shag/OS is free software for non-profit uses; it may be freely distributed
 *  for non-profit purposes under the terms of the Shag/OS License, version 1.
 *  
 *  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
 *  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
 *  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
 *  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
 *  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
 *  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
 *  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
 *  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
 *  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
 *  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
 *  
 *  You should have received a copy of the Shag/OS License along with this
 *  program, in a file called 'COPYING'.  If this license was not received,
 *  please contact the author and describe how this software was obtained.
 *  
 *  The author can be reached for questions, comments, and suggestions at:
 *  
 *      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
 *      email:   shaggy@csh.rit.edu
 *  
 *      For bug reports, please read the file 'BUGS' first, then include the 
 *      product name and version, and the word 'bug' in the subject.
 *  
 *  Complete, unaltered, original distributions of this and related code
 *  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
 *  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy
 */

// Device I/O interface:

#define DEVIO_ID	0x00		// device ID
#define DEVIO_RESV	0x01		// reserved
#define DEVIO_FLAGS	0x02		// default flags
#define DEVIO_BLK2SIZE	0x03		// default log2(blocksize)
#define DEVIO_OPEN	0x04		// open device
#define DEVIO_CLOSE	0x06		// close device
#define DEVIO_READ	0x08		// read function
#define DEVIO_WRITE	0x0a		// write function
#define DEVIO_SIZEOF	0x0c



// Open file descriptor:

#define FD_DEVPTR	0x00	// pointer to device structure
#define FD_MAPPTR	0x02	// pointer to mapfile entry (null if unused)
#define FD_POS		0x04	// current position in file
#define FD_UNIT		0x08	// device unit number
#define FD_BLK2SIZE	0x0a	// log2(block size)
#define FD_FLAGS	0x0b	// device flags
#define FD_FSIZE	0x0c	// total file size
#define FD_DATA		0x10	// 16 bytes of device-dependent data
#define FD_SIZEOF	0x20

#define FD_FLAG_READ	0x01	// device can be read from
#define FD_FLAG_WRITE	0x02	// device can be written to
#define FD_FLAG_FILE	0x08	// fd represents a mapped file
#define FD_FLAG_64K	0x10	// buffer cannot cross 64K boundary
#define FD_FLAG_BLOCK	0x20	// device is a block device
#define FD_FLAG_CHAR	0x40	// device is a character device

