//  $Id: hello.C,v 1.3 1996/10/26 19:11:00 shaggy Exp $
//      An example standalone program that can be copied
//      to use as the base for writing other standalone programs
//      
//      relative path: ./sys/boot/m-pc
//  
//      Shag/OS: an Object-Oriented MicroKernel Operating System
//       System files
//        Boot loader
//         (m-pc)
//  
//  Copyright (c) 1996 Frank E. Barrus.  All rights reserved.
//  
//  This file is a part of the Shag/OS operating system distribution.
//  
//  Shag/OS is free software for non-profit uses; it may be freely distributed
//  for non-profit purposes under the terms of the Shag/OS License, version 1.
//  
//  THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT WARRANTY, EXPRESS OR IMPLIED.
//  THE AUTHOR SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF ANY KIND, 
//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
//  AND FITNESS FOR A PARTICULAR PURPOSE.  IN NO EVENT WILL THE AUTHOR, OR
//  ANYONE RESPONSIBLE FOR THE LEGAL MODIFICATION OR REDISTRIBUTION OF THIS
//  SOFTWARE, BE LIABLE FOR ANY DAMAGES, INCLUDING BUT NOT LIMITED TO ANY LOST
//  PROFITS, LOST SAVINGS OR ANY INCIDENTAL OR CONSEQUENTIAL DAMAGES, WHETHER
//  RESULTING FROM IMPAIRED OR LOST DATA, SOFTWARE OR COMPUTER FAILURE OR ANY
//  OTHER CAUSE, EVEN IF THE AUTHOR IS ADVISED OF THE POSSIBILITY OF SUCH
//  DAMAGES, OR FOR ANY OTHER CLAIM BY THE USER OR FOR ANY THIRD PARTY CLAIM.
//  
//  You should have received a copy of the Shag/OS License along with this
//  program, in a file called 'COPYING'.  If this license was not received,
//  please contact the author and describe how this software was obtained.
//  
//  The author can be reached for questions, comments, and suggestions at:
//  
//      Frank Barrus, 4435 River Rd. Apt #3, Scottsville, NY 14546, USA
//      email:   shaggy@csh.rit.edu
//  
//      For bug reports, please read the file 'BUGS' first, then include the 
//      product name and version, and the word 'bug' in the subject.
//  
//  Complete, unaltered, original distributions of this and related code
//  may be obtained from:   http://www.csh.rit.edu/~shaggy/software.html
//  or:	ftp://ftp.csh.rit.edu/pub/csh/shaggy

  

#define hello_VER_MAJOR	1
#define hello_VER_MINOR	0
#define hello_VER_PATCH	0
#define hello_VER_STR	"1.0"
#define hello_VER_DATE	"October 05, 1996"
#define hello_VER_NDATE	"10/05/96"

//  $Log: hello.C,v $
//  Revision 1.3  1996/10/26  19:11:00  shaggy
//  header update
//
//  Revision 1.2  1996/10/05  11:51:51  shaggy
//  hello 1.0.0 (October 05, 1996: 07:51:49)
//  	- absolutely finished and complete
//  	  (and one of the few programs that ever really can be)
//
//  ==========================================================================
//
//  Revision 1.1  1996/10/05  11:49:28  shaggy
//  Initial revision
//


#include <defines>
#include <posix/string.h>
#include <posix/stdlib.h>
#include <boot/libsolo.h>


static char rcsid[] __attribute__((unused))
	= "$Id: hello.C,v 1.3 1996/10/26 19:11:00 shaggy Exp $"
	  "$Release: " hello_VER_STR " $";





main(int argc, char **argv)
{
	if(argc == 2 && !strcmp(argv[1], "-v")) {
		printf("hello " hello_VER_STR "\n");
		exit(0);
	}
	
	if(argc != 1) {	
		printf("usage: %s [-v]\n", argv[0]);
		exit(1);
	}
	
	printf("HeLlO wOrLD\n");
}

